(**************************************************************************)
(*                                                                        *)
(*  This file is part of the Frama-C's E-ACSL plug-in.                    *)
(*                                                                        *)
(*  Copyright (C) 2012                                                    *)
(*    CEA (Commissariat  l'nergie atomique et aux nergies              *)
(*         alternatives)                                                  *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

open Cil_types

(** Typing rules. *)

(* TODO: to be improved *)

val principal_type: logic_type -> logic_type -> logic_type
val principal_type_from_term: term -> term -> logic_type

val context_sensitive: 
  ?loc:location -> Env.t -> logic_type -> bool -> term option -> exp -> 
  exp * Env.t

val is_representable: My_bigint.t -> ikind -> string option -> bool
(** Is the given constant representable?
    (See [Cil_types.CInt64] for details about arguments *)

(*
Local Variables:
compile-command: "make"
End:
*)
